Last Comment Bug 681870 - IndexedDB: Prompts can crash when multiple windows are open
: IndexedDB: Prompts can crash when multiple windows are open
Status: VERIFIED FIXED
: verified-aurora, verified-beta
Product: Core
Classification: Components
Component: DOM: IndexedDB (show other bugs)
: unspecified
: x86_64 Windows 7
: -- normal (vote)
: ---
Assigned To: Jonas Sicking (:sicking) No longer reading bugmail consistently
:
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-08-24 22:42 PDT by Ben Turner (not reading bugmail, use the needinfo flag!)
Modified: 2012-03-22 11:51 PDT (History)
6 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed
fixed


Attachments
Patch to fix (1.11 KB, patch)
2011-08-24 23:11 PDT, Jonas Sicking (:sicking) No longer reading bugmail consistently
bent.mozilla: review+
blizzard: approval‑mozilla‑aurora+
blizzard: approval‑mozilla‑beta+
Details | Diff | Splinter Review

Description Ben Turner (not reading bugmail, use the needinfo flag!) 2011-08-24 22:42:50 PDT
Sicking figured out our phantom prompt crash today, and will attach a patch shortly.
Comment 1 Jonas Sicking (:sicking) No longer reading bugmail consistently 2011-08-24 23:11:55 PDT
Created attachment 555659 [details] [diff] [review]
Patch to fix
Comment 2 Jonas Sicking (:sicking) No longer reading bugmail consistently 2011-08-24 23:21:22 PDT
Checked in to inbound:

http://hg.mozilla.org/integration/mozilla-inbound/rev/458f82155cad
Comment 3 Jonas Sicking (:sicking) No longer reading bugmail consistently 2011-08-24 23:23:30 PDT
Comment on attachment 555659 [details] [diff] [review]
Patch to fix

This fixes a pretty nasty bug in our indexedDB code. The result is that we end up crashing in case the user has multiple windows open when a indexedDB database is created.

The risk is very low as the fix is very simple. It also only affects indexedDB code, so worst case it shouldn't affect many sites as indexedDB isn't widely used yet.
Comment 4 Marco Bonardo [::mak] 2011-08-25 04:39:03 PDT
http://hg.mozilla.org/mozilla-central/rev/458f82155cad
Comment 5 Christopher Blizzard (:blizzard) 2011-08-25 14:27:47 PDT
Comment on attachment 555659 [details] [diff] [review]
Patch to fix

Approved for Beta (Update 7) and Aurora (Update 8).  Please check it in as soon as possible.

Also clearing the 1.9.2.21 flag as we didn't include this before Firefox 4.
Comment 7 Ioana (away) 2011-08-30 02:45:38 PDT
Can anyone please help me with some STR/guidelines I can use to verify this fix?
Comment 8 Ben Turner (not reading bugmail, use the needinfo flag!) 2011-08-30 09:39:04 PDT
(In reply to Ioana Budnar [QA] from comment #7)
> Can anyone please help me with some STR/guidelines I can use to verify this
> fix?

The only way we were able to reproduce this was to open two browser windows (not tabs, but windows), and point one to a site that uses IndexedDB but had never been granted permission before. Initiating IndexedDB usage then would trigger a prompt, sometimes in both windows, and clicking Allow in both prompts would cause a crash. IndexedDB should only ever produce a prompt in one window.
Comment 9 Ben Turner (not reading bugmail, use the needinfo flag!) 2011-08-30 09:43:27 PDT
(In reply to ben turner [:bent] from comment #8)
> ... and point one to a site that uses IndexedDB

One such site is http://davidflanagan.com/demos/zipcodes.html
Comment 10 Ioana (away) 2011-09-09 08:30:44 PDT
Verified fixed on:
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:7.0) Gecko/20100101 Firefox/7.0
Build ID: 20110902161802

STR:
1. Open 2 Fx windows.
2. Load http://davidflanagan.com/demos/zipcodes.html in both windows.
3. Input a zip code in one of the windows (or both).
4. Click on the Allow button in the prompt.
The prompt with the Allow button only appears in one of the windows. Firefox works fine after clicking the Allow button.
Comment 11 Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2011-09-09 15:42:14 PDT
QA tracking; still needs verification on Firefox 8.
Comment 12 Ioana (away) 2011-09-11 23:44:10 PDT
Verified fixed on:
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:8.0a2) Gecko/20110911 Firefox/8.0a2 
Build ID: 20110911042006
Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:9.0a1) Gecko/20110911 Firefox/9.0a1
Build ID: 20110911030845

STR:
1. Open 2 Fx windows.
2. Load http://davidflanagan.com/demos/zipcodes.html in both windows.
3. Input a zip code in one of the windows (or both).
4. Click on the Allow button in the prompt.
The prompt with the Allow button only appears in one of the windows. Firefox works fine after clicking the Allow button.

Note You need to log in before you can comment on or make changes to this bug.